> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/zec/instance/stopinstances.md).

# StopInstances

## 1. API Description

This API (StopInstances) is used to shut down one or more elastic compute instances.

{% hint style="info" %}
**Notes**

* This operation can be performed on instances in the running (`RUNNING`) or stopping (`STOPPING`) status. In some scenarios, a regular shutdown may fail. You can set `forceShutdown` = true to force a shutdown.
* This interface is asynchronous. The request to shut down instances returns immediately after it is sent successfully, but the operation is not completed at that point. The operation result can be queried by calling the [DescribeInstancesStatus](/api-reference/zec/instance/describeinstancesstatus.md) interface: if the instance status (`instanceStatus`) changes from `STOPPING` to `STOPPED`, the instance is shut down successfully. No operation can be performed on the instance during the shutdown.
* Batch operations are supported. Up to 100 instances can be operated on in each request.
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type            | Description                                                                                                                                                      |
| -------------- | -------- | --------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| instanceIds    | Yes      | Array of String | <p>ID of the instance to be shut down.</p><p>It can be obtained by calling <a href="/api-reference/zec/instance/describeinstances.md">DescribeInstances</a>.</p> |
| forceShutdown  | No       | Boolean         | <p>Whether to force shutdown.</p><p>If the value is empty, a forced shutdown will be performed by default.</p><p>Default value: true</p>                         |

## 3. Output Parameters

| Parameter Name | Type            | Description                                                                                                           |
| -------------- | --------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String          | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| instanceIds    | Array of String | A list of instance IDs that failed to shut down.                                                                      |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Shut down instances of the specified IDs.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: StopInstances
<Common Request Params>

Request:
{
  "instanceIds": [
    "instanceId1",
    "instanceId2"
  ],
  "forceShutdown":true
}

Response:
{
  "requestId": "TC1748D3E-452D-4F74-8485-7AA73718E453",
  "response": {
    "requestId": "TC1748D3E-452D-4F74-8485-7AA73718E453",
    "instanceIds": ["xxx","xxx"]
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                                 | Description                                                 |
| ---------------- | ------------------------------------------ | ----------------------------------------------------------- |
| 400              | OPERATION\_DENIED\_INSTANCE\_IN\_OPERATION | Instance is performing another operation.                   |
| 400              | UNSUPPORTED\_OPERATION\_INSTANCE\_STATUS   | Operations on instances in current state are not supported. |
